#include "usgard.h"
 .org 0
 .db "BATTLE SHIP v2.2 by Joa",0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;aliases
nb	=TEXT_MEM	;1 byte but TEXT_MEM+1 must be equal to 0
case	=TEXT_MEM+2	;1 byte but TEXT_MEM+3 must be equal to 0
let	=TEXT_MEM+4	;1 byte but TEXT_MEM+5 must be equal to 0
numb	=TEXT_MEM+6	;1 byte but TEXT_MEM+6 must be equal to 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start:
	ld hl,VIDEO_MEM
	ld (DEST_ADDR),hl
	ld de,0
	ld (case),de
        ld (nb),de
	ld (let),de
	ld (numb),de
	ld hl,&turn
	ld a,(hl)
	ld (nb),a
	call CLEARLCD
	ld hl,&titleS
	ld de,$0302
	ld (CURSOR_ROW),de
	call D_ZT_STR
	ld de,$0007	
	ld (CURSOR_ROW),de
	call D_ZT_STR
waitkey:
	call &waitfor_a_key_pressed
	cp K_F1
	jr z,new_game
	cp K_F5
	jr z,resume
	jr waitkey	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
new_game:
	call CLEARLCD
	ld hl,VIDEO_MEM	
	ld de,&board_a
	ld bc,400
	ldir
	ld hl,&ship_default
	ld de,&ship_a
	ld bc,10
	ldir
	ld hl,&turn
	ld (hl),3
	inc hl
	inc hl
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;player A
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&playera
	call D_ZT_STR		
	call &waitfor_a_key_pressed	
	ld de,1
	ld (nb),de
	call &choose_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;player B
	call CLEARLCD
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&playerb
	call D_ZT_STR		
	call &waitfor_a_key_pressed
	ld de,2
	ld (nb),de	
	call &choose_code
	ld hl,&turn
	ld (hl),1
	ld a,1
	ld (nb),a

resume:
	ld a,(nb)
	cp 3
        jp z,&start
	cp 2
	jr z,play_init_b
play_init_a:
	call CLEARLCD
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&playera
	call D_ZT_STR
	call &waitfor_a_key_pressed
	jr verif_code
play_init_b:
	call CLEARLCD
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&playerb
	call D_ZT_STR
	call &waitfor_a_key_pressed

verif_code:
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&entercodeS
	call D_ZT_STR
	call D_ZT_STR
	call D_ZT_STR
	call D_ZT_STR
	call D_ZT_STR

verif_code_two:
	ld de,(nb)
	ld hl,&turn
	add hl,de
	ld c,(hl)
	inc hl
	inc hl
	ld a,(hl)
	ld de,$0004
	ld (CURSOR_ROW),de
	#fncall D_a_dec
	call &waitfor_a_key_pressed
	cp c
	jr z,play
	ld a,(hl)
	dec a
	jp z,&end_game
	ld (hl),a
	ld de,$0004
	ld (CURSOR_ROW),de
	jr verif_code_two

play:
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&codecorrectS
	call D_ZT_STR
	call &waitfor_a_key_pressed
play_two:
	call &board_aorb
	call &display
	push hl
	call CLEARLCD
	ld hl,$3A00
	ld ($8333),hl
	ld hl,&targetS
	call D_ZM_STR
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop hl
	ld de,100
	add hl,de
	ld bc,$4200
	ld de,0
	ld (case),de
	call &put_cursor
	call &move_cursor_two
	push hl
	call &board_opposing_aorb
	ld de,(case)
	add hl,de
	ld a,(hl)
	or a
	jr z,missed
	cp 3
	jr z,aircraft_hit
	cp 4
	jr z,battle_hit
	cp 5
	jr z,cruiser_hit
	cp 6
	jr z,submarine_hit
	cp 7
        jp z,&destroyer_hit

missed:
	ld (hl),1
	pop hl
	ld (hl),1
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&inwaterS
	call D_ZT_STR
	call &change_turn
	call &waitfor_a_key_pressed
        jp &resume
aircraft_hit:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&aircraftS
	call D_ZT_STR
	call &ship_opposing_aorb
	jr disp_hit
battle_hit:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&battleS
	call D_ZT_STR
	call &ship_opposing_aorb
	inc hl
	jr disp_hit
cruiser_hit:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&cruiserS
	call D_ZT_STR
	call &ship_opposing_aorb
	inc hl
	inc hl
	jr disp_hit
submarine_hit:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&submarineS
	call D_ZT_STR
	call &ship_opposing_aorb
	inc hl
	inc hl
	inc hl
	jr disp_hit
destroyer_hit:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&destroyerS
	call D_ZT_STR
	call &ship_opposing_aorb
	inc hl
	inc hl
	inc hl
	inc hl
disp_hit:
	push hl
	ld hl,1
	ld (CURSOR_ROW),hl
	ld hl,&hitS
	call D_ZT_STR
	pop hl
	dec (hl)
	jr z,disp_sunk
	call &waitfor_a_key_pressed
        jp &play_two
disp_sunk:
	ld hl,&sunkS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &ship_opposing_aorb
	ld a,(hl)
	inc hl
	add a,(hl)
	inc hl
	add a,(hl)
	inc hl
	add a,(hl)
	inc hl
	add a,(hl)
	or a
        jp nz,&play_two
	ld hl,$0004
	ld (CURSOR_ROW),hl
	ld hl,&winS
	call D_ZT_STR
	call D_ZT_STR
end_game:
	ld hl,&turn
	ld (hl),3
	call &waitfor_a_key_pressed
	call OTH_EXIT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
choose_code:
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&presskeycodeS
	call D_ZT_STR
	call D_ZT_STR
	call &waitfor_a_key_pressed
	ld hl,&turn
	ld de,(nb)
	add hl,de
	ld (hl),a

put_aircraft:
	call CLEARLCD
	ld hl,$0103
	ld (CURSOR_ROW),hl
	ld hl,&aircraftS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &board_aorb
	call &display
	call &disp_first_caseS
	ld bc,0	;x,y of the 1st square
	call &put_cursor
	call &move_cursor_two
	call &disp_rordS
put_aircraft_rord:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,put_aircraft_right
	cp K_DOWN
	jr z,put_aircraft_down
	cp K_SECOND
	jr z,put_aircraft
	cp K_EXIT
	call z,&exit
	jr put_aircraft_rord
put_aircraft_right:
	ld a,b
	add a,24
	cp 55
	jr nc,put_aircraft
	ld b,4
	call &put_ship_right_verif
	or a
	jr nz,put_aircraft
	dec hl
	dec hl
	dec hl
	dec hl
	ld (hl),3
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
	jr put_battle
put_aircraft_down:
	ld a,c
	add a,24
	cp 55
	jr nc,put_aircraft
	ld b,4
	call &put_ship_down_verif
	or a
	jr nz,put_aircraft
	or a
	ld de,40
	sbc hl,de
	ld de,10
	ld (hl),3
	add hl,de
	ld (hl),3
	add hl,de
	ld (hl),3
	add hl,de
	ld (hl),3
	add hl,de
	ld (hl),3

put_battle:
	call CLEARLCD
	ld hl,$0403
	ld (CURSOR_ROW),hl
	ld hl,&battleS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &board_aorb
	call &display
	call &disp_first_caseS
	ld bc,0
	call &put_cursor
	call &move_cursor_two	
	call &disp_rordS
put_battle_rord:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,put_battle_right
	cp K_DOWN
	jr z,put_battle_down
	cp K_SECOND
	jr z,put_battle
	cp K_EXIT
	call z,&exit
	jr put_battle_rord
put_battle_right:
	ld a,b
	add a,18
	cp 55
	jr nc,put_battle
	ld b,3
	call &put_ship_right_verif
	or a
	jr nz,put_battle
	dec hl
	dec hl
	dec hl
	ld (hl),4
	inc hl
	ld (hl),4
	inc hl
	ld (hl),4
	inc hl
	ld (hl),4
	jr put_cruiser
put_battle_down:
	ld a,c
	add a,18
	cp 55
	jr nc,put_battle
	ld b,3
	call &put_ship_down_verif
	or a
	jr nz,put_battle
	or a
	ld de,30
	sbc hl,de
	ld de,10
	ld (hl),4
	add hl,de
	ld (hl),4
	add hl,de
	ld (hl),4
	add hl,de
	ld (hl),4

put_cruiser:
	call CLEARLCD
	ld hl,$0603
	ld (CURSOR_ROW),hl
	ld hl,&cruiserS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &board_aorb	
	call &display
	call &disp_first_caseS
	ld bc,0
	call &put_cursor
	call &move_cursor_two	
	call &disp_rordS
put_cruiser_rord:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,put_cruiser_right
	cp K_DOWN
	jr z,put_cruiser_down
	cp K_SECOND
	jr z,put_cruiser
	cp K_EXIT
	call z,&exit
	jr put_cruiser_rord
put_cruiser_right:
	ld a,b
	add a,12
	cp 55
	jr nc,put_cruiser
	ld b,2
	call &put_ship_right_verif
	or a
	jr nz,put_cruiser
	dec hl
	dec hl
	ld (hl),5
	inc hl
	ld (hl),5
	inc hl
	ld (hl),5
	jr put_submarine
put_cruiser_down:
	ld a,c
	add a,12
	cp 55
	jr nc,put_cruiser
	ld b,2
	call &put_ship_down_verif
	or a
	jr nz,put_cruiser
	or a
	ld de,20
	sbc hl,de
	ld de,10
	ld (hl),5
	add hl,de
	ld (hl),5
	add hl,de
	ld (hl),5

put_submarine:
	call CLEARLCD
	ld hl,$0503
	ld (CURSOR_ROW),hl
	ld hl,&submarineS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &board_aorb	
	call &display
	call &disp_first_caseS
	ld bc,0
	call &put_cursor
	call &move_cursor_two
	call &disp_rordS
put_submarine_rord:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,put_submarine_right
	cp K_DOWN
	jr z,put_submarine_down
	cp K_SECOND
	jr z,put_submarine
	cp K_EXIT
	call z,&exit
	jr put_submarine_rord
put_submarine_right:
	ld a,b
	add a,12
	cp 55
	jr nc,put_submarine
	ld b,2
	call &put_ship_right_verif
	or a
	jr nz,put_submarine
	dec hl
	dec hl
	ld (hl),6
	inc hl
	ld (hl),6
	inc hl
	ld (hl),6
	jr put_destroyer
put_submarine_down:
	ld a,c
	add a,12
	cp 55
	jr nc,put_submarine
	ld b,2
	call &put_ship_down_verif
	or a
	jr nz,put_submarine
	or a
	ld de,20
	sbc hl,de
	ld de,10
	ld (hl),6
	add hl,de
	ld (hl),6
	add hl,de
	ld (hl),6

put_destroyer:
	call CLEARLCD
	ld hl,$0503
	ld (CURSOR_ROW),hl
	ld hl,&destroyerS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &board_aorb
	call &display
	call &disp_first_caseS
	ld bc,0
	call &put_cursor
	call &move_cursor_two	
	call &disp_rordS
put_destroyer_rord:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,put_destroyer_right
	cp K_DOWN
	jr z,put_destroyer_down
	cp K_SECOND
	jr z,put_destroyer
	cp K_EXIT
	call z,&exit
	jr put_destroyer_rord
put_destroyer_right:
	ld a,b
	add a,6
	cp 55
	jr nc,put_destroyer
	ld b,1
	call &put_ship_right_verif
	or a
	jr nz,put_destroyer
	dec hl
	ld (hl),7
	inc hl
	ld (hl),7
	ret
put_destroyer_down:
	ld a,c
	add a,6
	cp 55
	jr nc,put_destroyer
	ld b,1
	call &put_ship_down_verif
	or a
	jr nz,put_destroyer
	or a
	ld de,10
	sbc hl,de
	ld de,10
	ld (hl),7
	add hl,de
	ld (hl),7
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
exit:
	ld hl,GRAPH_MEM
	ld bc,1023
	call OTH_CLEAR
	call OTH_EXIT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;differents sous-programmes
waitfor_a_key_pressed:
	push hl
	call GET_KEY
	pop hl
	or a
	jr z,waitfor_a_key_pressed
	cp K_EXIT
	call z,&exit
	ret
put_cursor:
	push hl
	push bc
	ld hl,&cursor
	#fncall Pspr_w
	ld a,5
	ld hl,$FFBE
clear:
	ld (hl),0
	inc hl
	ld (hl),0
	ld de,15
	add hl,de
	dec a
	jr nz,clear	
	ld hl,$3A72
	ld ($8333),hl
	ld hl,&numbers
	ld de,(numb)
	add hl,de
	ld a,(hl)
	#fncall Dm_a_dec
	ld hl,$3A71
	ld ($8333),hl
	ld hl,&letters
	ld de,(let)
	add hl,de
	ld a,(hl)
	call M_CHARPUT
	ld hl,GRAPH_MEM+941
	ld de,VIDEO_MEM+941
	ld bc,3
	ldir
	pop bc
	pop hl
	ret

board_aorb:
	ld a,(nb)
	cp 1
	jr z,board_aorb_a
	ld hl,&board_b
	ret
board_aorb_a:
	ld hl,&board_a
	ret

board_opposing_aorb:
	ld a,(nb)
	cp 1
	jr z,board_opposing_aorb_b
	ld hl,&board_a
	ret
board_opposing_aorb_b:
	ld hl,&board_b
	ret

ship_opposing_aorb:
	ld a,(nb)
	cp 1
	jr z,ship_opposing_aorb_b
	ld hl,&ship_a
	ret
ship_opposing_aorb_b:
	ld hl,&ship_b
	ret
change_turn:
	ld hl,&turn
	ld a,(nb)
	cp 1
	jr z,change_turn_a
	dec a
	ld (nb),a
	ld (hl),1
	ret
change_turn_a:
	inc a
	ld (nb),a
	ld (hl),2
	ret
	

disp_first_caseS:
	push hl
	call CLEARLCD
	ld hl,$3A00
	ld ($8333),hl
	ld hl,&first_caseS
	call D_ZM_STR
	ld hl,$GRAPH_MEM
	ld de,$VIDEO_MEM
	ld bc,944
	ldir
	ld de,0
	pop hl
	ret
disp_rordS:
	push hl
	push bc
	ld hl,$3A00
	ld ($8333),hl
	ld hl,&rordS
	call D_ZM_STR
	pop bc
	pop hl
	ret

put_ship_right_verif:
	inc hl
	ld a,(hl)
	or a
	ret nz
	djnz put_ship_right_verif
	ret

put_ship_down_verif:
	ld de,10
	add hl,de
	ld a,(hl)
	or a
	ret nz
	djnz put_ship_down_verif
	ret


move_cursor_two:
	call &move_cursor
	ld a,(hl)
	or a
	jr nz,move_cursor_two
	ret
move_cursor:
	push hl
	call GET_KEY
	pop hl
	cp K_DOWN
	call z,&mc_down
	cp K_LEFT
	call z,&mc_left
	cp K_RIGHT
        call z,&mc_right
	cp K_UP
	call z,&mc_up
	cp K_SECOND
	ret z
	cp K_EXIT
	call z,&exit
	jr move_cursor
mc_down:
	push af
	ld a,c
	cp 54
	jr z,mc_down_imp
	add a,6
	ld c,a
	ld de,10
	add hl,de
	push hl
	ld a,(case)
	add a,10
	ld (case),a
	ld a,(let)
	inc a
	ld (let),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir			;clear the cursor
	pop bc
	call &put_cursor
	pop hl
mc_down_imp:
	pop af
	ret
mc_up:
	push af
	ld a,c
	or a
	jr z,mc_up_imp
	sub 6
	ld c,a
	ld de,10
	or a
	sbc hl,de
	push hl
	ld a,(case)
	sub 10
	ld (case),a
	ld a,(let)
	dec a
	ld (let),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop bc
	call &put_cursor
	pop hl
mc_up_imp:
	pop af
	ret
mc_right:
	push af
	ld a,b
	cp 54
	jr z,mc_right_imp
	cp 120
	jr z,mc_right_imp
	add a,6
	ld b,a
	inc hl
	push hl
	ld a,(case)
	inc a
	ld (case),a
	ld a,(numb)
	inc a
	ld (numb),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop bc
	call &put_cursor
	pop hl
mc_right_imp:
	pop af
	ret
mc_left:
	push af
	ld a,b
	or a
        jr z,mc_left_imp
	cp 66
        jr z,mc_left_imp
	sub 6
	ld b,a
	dec hl
	push hl
	ld a,(case)
	dec a
	ld (case),a
	ld a,(numb)
	dec a
	ld (numb),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop bc
	call &put_cursor
	pop hl
mc_left_imp:
	pop af
	ret
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
display:
	push hl
	push hl
	call CLEARLCD
	ld de,0
	ld (let),de
	ld (numb),de
	pop hl
	ld bc,0	; x,y of the first square top left corner


display_sprite:
	ld a,(hl)
	or a
	call z,&sprite_empty
	cp 1
	call z,&sprite_inwater
	cp 2
	call z,&sprite_hit
	cp 3
	call nc,&sprite_ship	; if a is > or = to 3 ,put a ship square
	ld a,b
	cp 54
	jr z,row_next
	cp 120
	jr z,row_next
	add a,6
	ld b,a
	inc hl
	jr display_sprite
row_next:
	ld a,c
	cp 54
	jr z,board_next
	add a,6
	ld c,a
	ld a,b
	sub 54
	ld b,a
	inc hl
	jr display_sprite
board_next:
	ld a,b
	cp 120
	jr z,display_end
	ld bc,$4200
	inc hl
	jr display_sprite
display_end:
	ld hl,VIDEO_MEM
	ld de,GRAPH_MEM
	ld bc,944
	ldir
	pop hl
	ld bc,0
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sprite_inwater:
	push af
	push hl
	ld hl,&inwater
	call &PutSprite
	pop hl
	pop af
	ret
sprite_hit:
	push af
	push hl
	ld hl,&hit
	call &PutSprite
	pop hl
	pop af
	ret
sprite_ship:
	push af
	push hl
	ld hl,&ship
	call &PutSprite
	pop hl
	pop af
	ret
sprite_empty:
	push af
	push hl
	ld hl,&empty
	call &PutSprite
	pop hl
	pop af
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;putsprite routine de l'usgard school
PutSprite: ; Puts a sprite pointed to by HL at B,C
         push bc
         push de
         ld a,63
         sub c
         ld c,a
         push hl
         push hl
         call FIND_PIXEL
         ld de,$FC00
         add hl,de
         ex de,hl
         pop hl
         ld b,(hl)
         inc hl
         ld c,(hl)
         inc hl
         push hl
         pop ix
         ex de,hl
PS_NewRow:
         push bc
         ld d,(ix)
         inc ix
         push af
         push hl
PS_NewCol:
         rl d
         ld e,a
         jr nc,PS_NoPixel
         or (hl)
         jr PS_NextPixel
PS_NoPixel:
         cpl
         and (hl)
PS_NextPixel:
         ld (hl),a
         ld a,e
         rrca
         jr nc,PS_SameByte
         inc hl
PS_SameByte:
         djnz PS_NewCol
         pop hl
         pop af
         ld de,16
         add hl,de
         pop bc
         dec c
         jr nz,PS_NewRow
         pop hl
         pop de
         pop bc
         ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;string + data location + sprites et image

turn:
	.db 3,$00,$00		;0=player 1;1=player2;3=pas de partie chargeable;$00=emplacment pour le code a;$00=emplacement pour le code b
	.db 3,3	; number of remaining try for the code
ship_default:	;1:aircraft(5 squares),2:battle ship(4 squares),3:cruiser(...),4:submarine,5:destroyer
	.db 5,4,3,3,2
	.db 5,4,3,3,2

board_a:					;0 : nothing
	.db 0,0,0,0,0,0,0,0,0,0		;1 : missed
	.db 0,0,0,0,0,0,0,0,0,0		;2 : hit
	.db 0,0,0,0,0,0,0,0,0,0		;3 : aircraft-carrier
	.db 0,0,0,0,0,0,0,0,0,0		;4 : battle ship
	.db 0,0,0,0,0,0,0,0,0,0		;5 : cruiser
	.db 0,0,0,0,0,0,0,0,0,0		;6 : submarine
	.db 0,0,0,0,0,0,0,0,0,0		;7 : destroyer
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0

board_shoot_a:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0



board_b:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0

board_shoot_b:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0

ship_a:
	.db 5,4,3,3,2

ship_b:
	.db 5,4,3,3,2

playera:
	.db "PLAYER A",0
playerb:
	.db "PLAYER B",0
presskeycodeS:
	.db "Press the key which  ",0
	.db "will be your code.",0
entercodeS:
	.db "Press your keycode   "
	.db 0
	.db "you've just 3 try in "
	.db 0
	.db "all the game or the  "
	.db 0
	.db "game is over.        "
	.db 0
	.db "number of try:       "
	.db 0
winS:
	.db "   CONGRATULATION!   "
	.db 0
	.db "      YOU WON!"
	.db 0
codecorrectS:
	.db "GOOD CODE",0
first_caseS:
	.db "Choose the 1st square:",0
rordS:
	.db "Toward Right or Toward Down?",0
targetS:
	.db "What is the target?",0
inwaterS:
	.db "MISSED!"
	.db 0
hitS:
	.db "HIT!",0
sunkS:
	.db "and SUNK!",0
aircraftS:
	.db "AIRCRAFT CARRIER(5)",0
battleS:
	.db "BATTLE SHIP(4)",0
cruiserS:
	.db "CRUISER(3)",0
submarineS:
	.db "SUBMARINE(3)",0
destroyerS:
	.db "DESTROYER(2)",0
titleS:
	.db "BATTLE SHIP v2.2",0
	.db "F1-NEW      F5-RESUME",0
letters:
	.db 'A','B','C','D','E','F','G','H','I','J'
numbers:
	.db 1,2,3,4,5,6,7,8,9,10
inwater:
	.db 8,6
	.db %11000110
	.db %10101010
	.db %10010010
	.db %10101010
	.db %11000110
	.db %11111111
hit:
	.db 8,6
	.db %10010010
	.db %10111010
	.db %11111110
	.db %10111010
	.db %10010010
	.db %11111111
ship:
	.db 8,6
	.db %10010010
	.db %10101010
	.db %11000110
	.db %10101010
	.db %10010010
	.db %11111111
cursor:
	.db 8,5
	.db %00111000
	.db %01010100
	.db %01111100
	.db %01010100
	.db %00111000
empty:
	.db 8,6
	.db %10000010
	.db %10000010
	.db %10000010
	.db %10000010
	.db %10000010
	.db %11111111

.end

